const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const releaseNoteService = require("./releaseNote.service");
const redisClient = require("../../../../redisClient");

router.post("/", authorize(), getAll);
router.post("/create", authorize(), create);
router.post("/option", authorize(), option);
router.get("/last-version", authorize(), getLastVersion);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.put("/enabled/:id", authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
  releaseNoteService
    .create(req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function getAll(req, res, next) {
  releaseNoteService
    .getAll(req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function getLastVersion(req, res, next) {
  releaseNoteService
    .getLastVersion(req.query)
    .then((result) => res.json(result))
    .catch(next);
}

async function option(req, res, next) {
  try {
    // Membuat cacheKey
    const cacheKey = `cities-options`;

    // Mengecek apakah data sudah ada di Redis
    const cachedData = await redisClient.get(cacheKey);
    if (cachedData) {
      return res.json(JSON.parse(cachedData));
    }

    // Jika tidak ada, panggil releaseNoteService.option()
    const result = await releaseNoteService.option();

    // Simpan hasilnya ke Redis dengan expire time misalnya 60 detik
    await redisClient.setEx(cacheKey, 60, JSON.stringify(result));

    // Kembalikan response JSON dari hasil panggilan service
    return res.json(result);
  } catch (error) {
    return next(error);
  }
}

// function option(req, res, next) {
//   releaseNoteService
//     .option()
//     .then((result) => res.json(result))
//     .catch(next);
// }

function count(req, res, next) {
  releaseNoteService
    .count()
    .then((result) => res.json(result))
    .catch(next);
}

function update(req, res, next) {
  releaseNoteService
    .update(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function enabled(req, res, next) {
  releaseNoteService
    .enabled(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function _delete(req, res, next) {
  releaseNoteService
    .delete(req.params.id)
    .then((result) => res.json(result))
    .catch(next);
}
